//【登録場所】全体、レス表示
//【ラベル】ラベル名など
//【内容】特定のラベルが付いた書き込みをポップアップ
//【コマンド】${SCRIPT:Fr} popupLabel.js ラベル名1 ラベル名2 ...
//
// 例1：自分の書き込みをポップアップ（ラベル名が「書き込み」の場合）
// ${SCRIPT:Fr} popupLabel.js 書き込み
//
// 例2：指定ラベルの抽出
//「書き込み」ラベルか「デフォルト」ラベルのどちらかが付いたレスをポップアップ
// ${SCRIPT:Fr} popupLabel.js 書き込み デフォルト
//
// 例3：特殊なコマンド
// 全てのラベル付きレスをポップアップ
// ${SCRIPT:Fr} popupLabel.js ALL_LABEL
//
//【スクリプト】
// ----- 次の行から -----
var args = v2c.context.args;
if ( args.length >= 1 ) popupLabel( args );
else v2c.alert( '引数がありません' );

function popupLabel(com) {
	var i,j,max;
	var labels = '';
	var index = [];
	
	// ログファイルの情報ファイル(ラベル情報を含むファイル)を取得
	var buf = v2c.context.thread.localFile.getAbsolutePath() + '';
	buf = buf.split( '.' );
	buf.length--;
	var file = buf.join( '.' ) + '.txt';
	var ss = v2c.readLinesFromFile( file );
	if ( !ss ) return v2c.alert( 'ラベル情報ファイル取得失敗\n' + file );
	
	// ファイルの中からラベルの情報を取得
	for ( i = 0; i < ss.length; i++ ) {
		if( ss[i].match( /ThreadView\.ResLabels\:=(\d+?)\t(.+)/ ) ) {
			max = RegExp.$1;
			labels = RegExp.$2 + '';
		}
		// デバッグ用
		// v2c.print( ss[i] + '\n' );
	}
	if ( !labels || !max ) return v2c.alert( 'ラベル情報取得失敗' );
	
	// ラベルの分析処理
	var label = labels.split( '\t' );
	// 全てのラベルを抽出
	if ( com[0] == 'ALL_LABEL' ) {
		for ( i = 0; i < label.length; i++ ) {
			if( label[i].match( /([\d\,\-]+)\:.+/ ) )
				index = getLabelNum( RegExp.$1, max, index );
		}
	}
	// 指定されたラベルを抽出
	for ( i = 0; i < label.length; i++ ) {
		for ( j = 0; j < com.length; j++ ) {
			var reg = new RegExp( '([\\d\\,\\-]+)\\:' + com[j] , '' );
			if( label[i].match( reg ) ) 
				index = getLabelNum( RegExp.$1, max, index );
		}
	}
	if ( index.length < 1 )
		return v2c.alert( '該当ラベルなし\nラベル名：' + com );
	
	v2c.context.setPopupRes( index );
}

// ラベルの付いたレス番号のCSVを展開し配列に格納する
// str:CSV形式の数値、max:最大レス数、ary：レスインデックスの配列
function getLabelNum( str, max, ary ) {
	// v2c.print( str + '\n' );
	var num = str.split(',');
	for ( var i = 0; i < num.length; i++ ) {
		// v2c.print( num[i] + '\n' );
		if( num[i].match( /^(\d{1,4})$/ ) ) {
			var n1 = parseInt( RegExp.$1 );
			if ( ( -1 < n1 ) && ( n1 < ( max + 1 ) ) ) {
				ary.push( v2c.context.thread.getRes( n1 ) );
				// v2c.print( 'push:' + n1 + ':\n' );
			}
		}
		// 連番の展開
		else if ( num[i].match( /^(\d{1,4})\-(\d{1,4})$/ ) ) {
			var n1 = parseInt( RegExp.$1 );
			var n2 = parseInt( RegExp.$2 );
			v2c.print( 'n1:' + n1 + ':\n' );
			v2c.print( 'n2:' + n2 + ':\n' );
			if ( n1 < n2 ) {
				for ( var j = n1; j <= n2; j++ ) {
					if ( ( -1 < n1 ) && ( n1 < ( max + 1 ) ) ) {
						ary.push( v2c.context.thread.getRes( j ) );
						// v2c.print( 'push:' + j + ':\n' );
					}
				}
			}
		}
		else {
			v2c.print( 'ラベルCSV書式エラー\n' );
			return ary;
		}
	}
	return ary;
}
// ----- 前の行まで -----